var url = require('url');

module.exports = {
  site: {
    title: 'Example Site',
    subtitle: 'A site example generated by Hyde',
    author: 'Your Name',
    description: 'An example SEO description',
    url: url.parse('http://example.com'),
    root: '/',
    static: '/',
    permalink: '/blog/{year}/{month}/{day}/{title}',

    search: {
      provider: 'http://google.com/search'
    },

    theme: {
      name: 'default',
      files: {
        layout: 'default.jade',
        index: 'index.jade',
        page: 'page.jade',
        post: 'post.jade',
        archive: 'archive.jade',
        tags: 'tags.jade',
        date: 'date.jade'
      },
      dateFormat: 'dddd, dS mmmm yyyy @ h:MMTT',
      pagination: {
        number_to_page: 5,
        next_text: 'Next page',
        prev_text: 'Previous Page'
      }
    }
  },

  menu: {
    pull: 'right',
    items: [{
      text: 'Home',
      url: '/',
      classes: 'home'
    }, {
      text: 'About',
      url: 'about',
      classes: 'about'
    }, {
      text: 'Install',
      url: 'install',
      classes: 'install',
      children: [{
        text: 'via NPM',
        url: 'install/via-npm'
      }, {
        text: 'via Source',
        url: 'install/via-source'
      }]
    }]
  }
};